<?php
ob_start();

$guest_account = true;
chdir('../..');
include("./include/auth.php");
include_once("./plugins/memorize/setup.php");
input_validate_input_regex(get_request_var_request("action"), '^(showstats|flush)$');
ob_end_clean();
session_write_close();

if (get_request_var_request("action")=='showstats') {
    $curr=db_fetch_assoc("SELECT * FROM plugin_memorize_stats");
    $tot_displayed=count($curr);
    $tot_rendered_rrd=0;
    $tot_rendered_cc=0;
    $tot_rrd_render_time=0;
    $tot_cc_render_time=0;
    $avg_rrd_render_time=0;
    $avg_cc_render_time=0;
    $benefit=0;
    $mem_occupied=0;
    foreach ($curr as $rec) {
	    if ($rec['render_origin']==0) {
	    	$tot_rendered_rrd++;
	    	$tot_rrd_render_time+=$rec['render_duration'];
	    	if (($img_obj=shm_operate($rec['shm_addr']))==true)
	    	    $mem_occupied+=( strlen( serialize( $img_obj ) ) + 44 ) * 2;
	    	if ($time_obj=shm_operate(hash_and_clean("${rec['shm_addr']}stat",6))==true)
	    	    $mem_occupied+=( strlen( serialize( $time_obj ) ) + 44 ) * 2;
	    } else {
		$tot_rendered_cc++;
	    	$tot_cc_render_time+=$rec['render_duration'];
	    }
    }
    
    if ($tot_rendered_rrd>0)
	$avg_rrd_render_time=round($tot_rrd_render_time/$tot_rendered_rrd,6);
	
    if ($tot_rendered_cc>0)
	$avg_cc_render_time=round($tot_cc_render_time/$tot_rendered_cc,6);
    
    if ($avg_rrd_render_time>0 && $avg_cc_render_time>0)
	$benefit=round($avg_rrd_render_time/$avg_cc_render_time,6);
    
echo "<body><head><title>Memorize</title></head><body>
<table height=100% width=100%><tr><td align=left valign=middle>
<pre>
displayed graphs count:	$tot_displayed
rendered from rrd:	$tot_rendered_rrd
rendered from cache:	$tot_rendered_cc
avg rrd render time:	$avg_rrd_render_time
avg cache render time:	$avg_cc_render_time
benefit(times): 	$benefit
used cache memory size:	$mem_occupied
</pre>
</table>
</body></html>";
    
} elseif (get_request_var_request("action")=='flush') {
    $n=memorize_clean_old_data(true);
    echo "<body><head><title>Memorize</title></head><body><table height=100% width=100%><tr><td align=center valign=middle>$n records flushed from cache</td></tr></table></body></html>";
} else {
    die("wrong request");
}
?>